Index: src/parser.cpp
===================================================================
--- src/parser.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/parser.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -706,42 +986,42 @@
  */
 bool KeySetsContainer::ParseKeySets(const char *name, const int *ACounter, const int FCounter) {
-	ifstream input;
-	char *FragmentNumber = NULL;
-	stringstream file;
-	char filename[1023];
-
-	FragmentCounter = FCounter;
-	cout << "Parsing key sets." << endl;
-	KeySets = (int **) Malloc(sizeof(int *)*FragmentCounter, "KeySetsContainer::ParseKeySets: **KeySets");
-	for(int i=FragmentCounter;i--;)
-		KeySets[i] = NULL;
-	file << name << FRAGMENTPREFIX << KEYSETFILE;
-	input.open(file.str().c_str(), ios::in);
-	if (input == NULL) {
-		cout << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl;
-		return false;
-	}
-
-	AtomCounter = (int *) Malloc(sizeof(int)*FragmentCounter, "KeySetsContainer::ParseKeySets: *RowCounter");
-	for(int i=0;(i<FragmentCounter) && (!input.eof());i++) {
-		stringstream line;
-		AtomCounter[i] = ACounter[i];
-		// parse the values
-		KeySets[i] = (int *) Malloc(sizeof(int)*AtomCounter[i], "KeySetsContainer::ParseKeySets: *KeySets[]");
-		for(int j=AtomCounter[i];j--;)
-			KeySets[i][j] = -1;
-		FragmentNumber = FixedDigitNumber(FragmentCounter, i);
-		//cout << FRAGMENTPREFIX << FragmentNumber << "[" << AtomCounter[i] << "]:";
-		Free((void **)&FragmentNumber, "KeySetsContainer::ParseKeySets: *FragmentNumber");
-		input.getline(filename, 1023);
-		line.str(filename);
-		for(int j=0;(j<AtomCounter[i]) && (!line.eof());j++) {
-			line >> KeySets[i][j];
-			//cout << " " << KeySets[i][j];
-		}
-		//cout << endl;
-	}
-	input.close();
-	return true;
+  ifstream input;
+  char *FragmentNumber = NULL;
+  stringstream file;
+  char filename[1023];
+
+  FragmentCounter = FCounter;
+  cout << "Parsing key sets." << endl;
+  KeySets = (int **) Malloc(sizeof(int *)*FragmentCounter, "KeySetsContainer::ParseKeySets: **KeySets");
+  for(int i=FragmentCounter;i--;)
+    KeySets[i] = NULL;
+  file << name << FRAGMENTPREFIX << KEYSETFILE;
+  input.open(file.str().c_str(), ios::in);
+  if (input == NULL) {
+    cout << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl;
+    return false;
+  }
+
+  AtomCounter = (int *) Malloc(sizeof(int)*FragmentCounter, "KeySetsContainer::ParseKeySets: *RowCounter");
+  for(int i=0;(i<FragmentCounter) && (!input.eof());i++) {
+    stringstream line;
+    AtomCounter[i] = ACounter[i];
+    // parse the values
+    KeySets[i] = (int *) Malloc(sizeof(int)*AtomCounter[i], "KeySetsContainer::ParseKeySets: *KeySets[]");
+    for(int j=AtomCounter[i];j--;)
+      KeySets[i][j] = -1;
+    FragmentNumber = FixedDigitNumber(FragmentCounter, i);
+    //cout << FRAGMENTPREFIX << FragmentNumber << "[" << AtomCounter[i] << "]:";
+    Free((void **)&FragmentNumber, "KeySetsContainer::ParseKeySets: *FragmentNumber");
+    input.getline(filename, 1023);
+    line.str(filename);
+    for(int j=0;(j<AtomCounter[i]) && (!line.eof());j++) {
+      line >> KeySets[i][j];
+      //cout << " " << KeySets[i][j];
+    }
+    //cout << endl;
+  }
+  input.close();
+  return true;
 };
 
@@ -751,58 +1031,58 @@
 bool KeySetsContainer::ParseManyBodyTerms()
 {
-	int Counter;
-
-	cout << "Creating Fragment terms." << endl;
-	// scan through all to determine maximum order
-	Order=0;
-	for(int i=FragmentCounter;i--;) {
-		Counter=0;
-		for(int j=AtomCounter[i];j--;)
-			if (KeySets[i][j] != -1)
-				Counter++;
-		if (Counter > Order)
-			Order = Counter;
-	}
-	cout << "Found Order is " << Order << "." << endl;
-
-	// scan through all to determine fragments per order
-	FragmentsPerOrder = (int *) Malloc(sizeof(int)*Order, "KeySetsContainer::ParseManyBodyTerms: *FragmentsPerOrder");
-	for(int i=Order;i--;)
-		FragmentsPerOrder[i] = 0;
-	for(int i=FragmentCounter;i--;) {
-		Counter=0;
-		for(int j=AtomCounter[i];j--;)
-			if (KeySets[i][j] != -1)
-				Counter++;
-		FragmentsPerOrder[Counter-1]++;
-	}
-	for(int i=0;i<Order;i++)
-		cout << "Found No. of Fragments of Order " << i+1 << " is " << FragmentsPerOrder[i] << "." << endl;
-
-	// scan through all to gather indices to each order set
-	OrderSet = (int **) Malloc(sizeof(int *)*Order, "KeySetsContainer::ParseManyBodyTerms: **OrderSet");
-	for(int i=Order;i--;)
-		OrderSet[i] = (int *) Malloc(sizeof(int)*FragmentsPerOrder[i], "KeySetsContainer::ParseManyBodyTermsKeySetsContainer::ParseManyBodyTerms: *OrderSet[]");
-	for(int i=Order;i--;)
-		FragmentsPerOrder[i] = 0;
-	for(int i=FragmentCounter;i--;) {
-		Counter=0;
-		for(int j=AtomCounter[i];j--;)
-			if (KeySets[i][j] != -1)
-				Counter++;
-		OrderSet[Counter-1][FragmentsPerOrder[Counter-1]] = i;
-		FragmentsPerOrder[Counter-1]++;
-	}
-	cout << "Printing OrderSet." << endl;
-	for(int i=0;i<Order;i++) {
-		for (int j=0;j<FragmentsPerOrder[i];j++) {
-			cout << " " << OrderSet[i][j];
-		}
-		cout << endl;
-	}
-	cout << endl;
-
-
-	return true;
+  int Counter;
+
+  cout << "Creating Fragment terms." << endl;
+  // scan through all to determine maximum order
+  Order=0;
+  for(int i=FragmentCounter;i--;) {
+    Counter=0;
+    for(int j=AtomCounter[i];j--;)
+      if (KeySets[i][j] != -1)
+        Counter++;
+    if (Counter > Order)
+      Order = Counter;
+  }
+  cout << "Found Order is " << Order << "." << endl;
+
+  // scan through all to determine fragments per order
+  FragmentsPerOrder = (int *) Malloc(sizeof(int)*Order, "KeySetsContainer::ParseManyBodyTerms: *FragmentsPerOrder");
+  for(int i=Order;i--;)
+    FragmentsPerOrder[i] = 0;
+  for(int i=FragmentCounter;i--;) {
+    Counter=0;
+    for(int j=AtomCounter[i];j--;)
+      if (KeySets[i][j] != -1)
+        Counter++;
+    FragmentsPerOrder[Counter-1]++;
+  }
+  for(int i=0;i<Order;i++)
+    cout << "Found No. of Fragments of Order " << i+1 << " is " << FragmentsPerOrder[i] << "." << endl;
+
+  // scan through all to gather indices to each order set
+  OrderSet = (int **) Malloc(sizeof(int *)*Order, "KeySetsContainer::ParseManyBodyTerms: **OrderSet");
+  for(int i=Order;i--;)
+    OrderSet[i] = (int *) Malloc(sizeof(int)*FragmentsPerOrder[i], "KeySetsContainer::ParseManyBodyTermsKeySetsContainer::ParseManyBodyTerms: *OrderSet[]");
+  for(int i=Order;i--;)
+    FragmentsPerOrder[i] = 0;
+  for(int i=FragmentCounter;i--;) {
+    Counter=0;
+    for(int j=AtomCounter[i];j--;)
+      if (KeySets[i][j] != -1)
+        Counter++;
+    OrderSet[Counter-1][FragmentsPerOrder[Counter-1]] = i;
+    FragmentsPerOrder[Counter-1]++;
+  }
+  cout << "Printing OrderSet." << endl;
+  for(int i=0;i<Order;i++) {
+    for (int j=0;j<FragmentsPerOrder[i];j++) {
+      cout << " " << OrderSet[i][j];
+    }
+    cout << endl;
+  }
+  cout << endl;
+
+
+  return true;
 };
 
@@ -814,16 +1094,16 @@
 bool KeySetsContainer::Contains(const int GreaterSet, const int SmallerSet)
 {
-	bool result = true;
-	bool intermediate;
-	if ((GreaterSet < 0) || (SmallerSet < 0) || (GreaterSet > FragmentCounter) || (SmallerSet > FragmentCounter)) // index out of bounds
-		return false;
-	for(int i=AtomCounter[SmallerSet];i--;) {
-		intermediate = false;
-		for (int j=AtomCounter[GreaterSet];j--;)
-			intermediate = (intermediate || ((KeySets[SmallerSet][i] == KeySets[GreaterSet][j]) || (KeySets[SmallerSet][i] == -1)));
-		result = result && intermediate;
-	}
-
-	return result;
+  bool result = true;
+  bool intermediate;
+  if ((GreaterSet < 0) || (SmallerSet < 0) || (GreaterSet > FragmentCounter) || (SmallerSet > FragmentCounter)) // index out of bounds
+    return false;
+  for(int i=AtomCounter[SmallerSet];i--;) {
+    intermediate = false;
+    for (int j=AtomCounter[GreaterSet];j--;)
+      intermediate = (intermediate || ((KeySets[SmallerSet][i] == KeySets[GreaterSet][j]) || (KeySets[SmallerSet][i] == -1)));
+    result = result && intermediate;
+  }
+
+  return result;
 };
 
Index: src/parser.hpp
===================================================================
--- src/parser.hpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/parser.hpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -19,15 +19,21 @@
 
 #define EnergySuffix ".energy.all"
+#define EnergyFragmentSuffix ".energyfragment.all"
+#define ForcesSuffix ".forces.all"
+#define ForceFragmentSuffix ".forcefragment.all"
 #define HcorrectionSuffix ".Hcorrection.all"
-#define ForcesSuffix ".forces.all"
+#define HcorrectionFragmentSuffix ".Hcorrectionfragment.all"
+#define HessianSuffix ".hessian_xx.all"
+#define HessianFragmentSuffix ".hessianfragment_xx.all"
+#define OrderSuffix ".Order"
 #define ShieldingSuffix ".sigma_all.csv"
 #define ShieldingPASSuffix ".sigma_all_PAS.csv"
 #define ShieldingFragmentSuffix ".sigma_all_fragment.all"
 #define ShieldingPASFragmentSuffix ".sigma_all_PAS_fragment.all"
+#define ChiSuffix ".chi_all.csv"
+#define ChiPASSuffix ".chi_all_PAS.csv"
+#define ChiFragmentSuffix ".chi_all_fragment.all"
+#define ChiPASFragmentSuffix ".chi_all_PAS_fragment.all"
 #define TimeSuffix ".speed"
-#define EnergyFragmentSuffix ".energyfragment.all"
-#define HcorrectionFragmentSuffix ".Hcorrectionfragment.all"
-#define ForceFragmentSuffix ".forcefragment.all"
-#define OrderSuffix ".Order"
 
 // ======================================= FUNCTIONS ==========================================
@@ -40,28 +46,29 @@
 
 class MatrixContainer {
-	public:
-		double ***Matrix;
-		int **Indices;
-		char *Header;
-		int MatrixCounter;
-		int *RowCounter;
-		int ColumnCounter;
-
-	MatrixContainer();
-	virtual ~MatrixContainer();
-
-	bool ParseMatrix(const char *name, int skiplines, int skipcolumns, int MatrixNr);
-	virtual bool ParseFragmentMatrix(const char *name, const char *prefix, string suffix, int skiplines, int skipcolumns);
-	bool AllocateMatrix(const char *GivenHeader, int MCounter, int *RCounter, int CCounter);
-	bool ResetMatrix();
-	double FindMinValue();
-	double FindMaxValue();
-	bool SetLastMatrix(double value, int skipcolumns);
-	bool SetLastMatrix(double **values, int skipcolumns);
-	//bool ParseIndices();
-	//bool SumSubValues();
-	bool SumSubManyBodyTerms(class MatrixContainer &Matrix, class KeySetsContainer &KeySet, int Order);
-	bool WriteTotalFragments(const char *name, const char *prefix);
-	bool WriteLastMatrix(const char *name, const char *prefix, const char *suffix);
+  public:
+    double ***Matrix;
+    int **Indices;
+    char **Header;
+    int MatrixCounter;
+    int *RowCounter;
+    int *ColumnCounter;
+  
+  MatrixContainer();
+  ~MatrixContainer();
+  
+  bool InitialiseIndices(class MatrixContainer *Matrix = NULL);
+  bool ParseMatrix(const char *name, int skiplines, int skipcolumns, int MatrixNr);
+  virtual bool ParseFragmentMatrix(const char *name, const char *prefix, string suffix, int skiplines, int skipcolumns);
+  bool AllocateMatrix(char **GivenHeader, int MCounter, int *RCounter, int *CCounter);
+  bool ResetMatrix();
+  double FindMinValue();
+  double FindMaxValue();
+  bool SetLastMatrix(double value, int skipcolumns);
+  bool SetLastMatrix(double **values, int skipcolumns);
+  //bool ParseIndices();
+  //bool SumSubValues();
+  bool SumSubManyBodyTerms(class MatrixContainer &Matrix, class KeySetsContainer &KeySet, int Order);
+  bool WriteTotalFragments(const char *name, const char *prefix);
+  bool WriteLastMatrix(const char *name, const char *prefix, const char *suffix);
 };
 
@@ -69,8 +76,8 @@
 
 class EnergyMatrix : public MatrixContainer {
-	public:
-		bool ParseIndices();
-		bool SumSubEnergy(class EnergyMatrix &Fragments, class EnergyMatrix *CorrectionFragments, class KeySetsContainer &KeySet, int Order, double sign);
-		bool ParseFragmentMatrix(const char *name, const char *prefix, string suffix, int skiplines, int skipcolumns);
+  public:
+    bool ParseIndices();
+    bool SumSubEnergy(class EnergyMatrix &Fragments, class EnergyMatrix *CorrectionFragments, class KeySetsContainer &KeySet, int Order, double sign);
+    bool ParseFragmentMatrix(const char *name, const char *prefix, string suffix, int skiplines, int skipcolumns);
 };
 
@@ -78,8 +85,22 @@
 
 class ForceMatrix : public MatrixContainer {
-	public:
-		bool ParseIndices(const char *name);
-		bool SumSubForces(class ForceMatrix &Fragments, class KeySetsContainer &KeySet, int Order, double sign);
-		bool ParseFragmentMatrix(const char *name, const char *prefix, string suffix, int skiplines, int skipcolumns);
+  public:
+    bool ParseIndices(const char *name);
+    bool SumSubForces(class ForceMatrix &Fragments, class KeySetsContainer &KeySet, int Order, double sign);
+    bool ParseFragmentMatrix(const char *name, const char *prefix, string suffix, int skiplines, int skipcolumns);
+};
+
+// ======================================= CLASS HessianMatrix =============================
+
+class HessianMatrix : public MatrixContainer { 
+  public: 
+    HessianMatrix();
+    //~HessianMatrix();
+    bool ParseIndices(char *name);
+    bool SumSubManyBodyTerms(class MatrixContainer &MatrixValues, class KeySetsContainer &KeySet, int Order);
+    bool SumSubHessians(class HessianMatrix &Fragments, class KeySetsContainer &KeySet, int Order, double sign);
+    bool ParseFragmentMatrix(const char *name, const char *prefix, string suffix, int skiplines, int skipcolumns);
+  private:
+    bool IsSymmetric;
 };
 
@@ -87,18 +108,18 @@
 
 class KeySetsContainer {
-	public:
-		int **KeySets;
-		int *AtomCounter;
-		int FragmentCounter;
-		int Order;
-		int *FragmentsPerOrder;
-		int **OrderSet;
+  public:
+    int **KeySets;
+    int *AtomCounter;
+    int FragmentCounter;
+    int Order;
+    int *FragmentsPerOrder;
+    int **OrderSet;
 
-	KeySetsContainer();
-	~KeySetsContainer();
+  KeySetsContainer();
+  ~KeySetsContainer();
 
-	bool ParseKeySets(const char *name, const int *ACounter, const int FCounter);
-	bool ParseManyBodyTerms();
-	bool Contains(const int GreaterSet, const int SmallerSet);
+  bool ParseKeySets(const char *name, const int *ACounter, const int FCounter);
+  bool ParseManyBodyTerms();
+  bool Contains(const int GreaterSet, const int SmallerSet);
 };
 
